#if 0
findword.exe: findword.c; cl findword.c /Ox /G6Fy /MD /link /opt:nowin98
	del findword.obj
!if 0
#endif

		//       File: #Words |Head Letter Sibleng Child IsWord | #Nodes SibLists KDict RawTree
		//--------------------+---------------------------------+----------------------------------------
		//  twl06.txt: 178691 | 12  67359  10562  139324 14485  | 126755   54308 231741 507024(4byt/node)
		//sowpods.txt: 216553 | 12  78896  12572  168436 16856  | 148466   60306 276771 593868(4byt/node)

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

#define MAXWORDLENG 256
static long maxwordleng = 0;

	//*a*b*c*d*e*f*g*h*i*j*k*l*m*n*o*p* Could be MAXWORDLENG long
static char globst[((MAXWORDLENG<<1)+1)*(MAXWORDLENG+1)];
static long matchcnt = 0;

//--------------------------------------------------------------------------------------------------
	//let tree structure:
	//   3322222222221111111111
	//   10987654321098765432109876543210
	//   --------------------------------
	//   [  child/suffix index  ][A-Z]
	//                           reserved(0)
	//                           is_word
	//                           is_sibling_tail
static long *let = 0, letn;
static char *words = 0;

	//Brute force word tree generator
static long numwords, wordsiz;
long searchsibly (long x, long y0, long y1)
{
	long i, j, y, oy, ny0[27], ny1[27], nyn, oletn;
	char ch, nyc[27];

	ch = words[y0*wordsiz+x]; oy = y0; nyn = 0;
	for(y=y0+1;y<y1;y++)
		if (words[y*wordsiz+x] != ch)
		{
			if (ch) { nyc[nyn] = ch; ny0[nyn] = oy; ny1[nyn] = y; nyn++; }
			ch = words[y*wordsiz+x]; oy = y;
		}
	if (ch) { nyc[nyn] = ch; ny0[nyn] = oy; ny1[nyn] = y1; nyn++; }
	if (!nyn) return(0);

	oletn = letn; letn += nyn;
	for(i=0;i<nyn;i++)
	{
		j = searchsibly(x+1,ny0[i],ny1[i]);
		let[oletn+i] = (nyc[i]&31) + ((!words[ny0[i]*wordsiz+x+1])<<6) + ((i==nyn-1)<<7) + (j<<8);
	}
	return(oletn);
}

static FILE *gdumpfil;
void dumpwords (char *st, long x, long i)
{
	i--;
	do
	{
		i++;
		st[x] = (let[i]&31)+64;
		if (let[i]&64) { st[x+1] = 0; fprintf(gdumpfil,"%s\n",st); }
		if (let[i]&0xffffff00) dumpwords(st,x+1,let[i]>>8);
	} while (!(let[i]&128));
}

static long crctab32[256];
void initcrc32 ()
{
	long i, j, k;
	for(i=255;i>=0;i--)
	{
		k = i;
		for(j=8;j;j--) k = ((unsigned long)k>>1)^((-(k&1))&0xedb88320);
		crctab32[i] = k;
	}
}
#define updatecrc32(c,crc) crc=(crctab32[(crc^c)&255]^(((unsigned)crc)>>8))
long treegetcrc32 (int i, long crc32)
{
	i = (let[i]>>8);
	if (!i) { updatecrc32(0,crc32); return(crc32); }
	i--;
	do
	{
		i++;
		updatecrc32(let[i],crc32);
		if (let[i]&0xffffff00) crc32 = treegetcrc32(i,crc32);
	} while (!(let[i]&128));
	updatecrc32(0,crc32);
	return(crc32);
}

static long *let2 = 0, letn2 = 0;
int treematch (int i0, int i1)
{
	i0 = (let[i0]>>8);
	i1 = (let2[i1]>>8); if ((!i0) != (!i1)) return(0);
	if (!i0) return(1);
	i0--; i1--;
	do
	{
		i0++; i1++;
		if ((let[i0]&255) != (let2[i1]&255)) return(0);
		if (!treematch(i0,i1)) return(0);
	} while (!(let[i0]&128));
	return(1);
}

#define LHASHSIZ 17 //Mcc per LHASHSIZ: 12:388,13:284,14:230,15:204,16:191,17:188,18:188,19:189
static long *hashead, *hashnext;
static void suffixmatchtree (int i)
{
	int j, l, hashval, oletcnt;

	oletcnt = letn2-i;
	for(l=i;!(let[l]&128);l++);
	letn2 += l-i+1;

	i--;
	do
	{
		i++;
		l = let[i];
		if (!(l&0xffffff00)) { let2[oletcnt+i] = l; continue; }
		hashval = (treegetcrc32(i,-1)&((1<<LHASHSIZ)-1));
		for(j=hashead[hashval];j>=0;j=hashnext[j])
			if (treematch(i,j))
			{
					//Can't allow rewired forward pointers: corrupts assumption by compressor!
				if ((let2[j]>>8) >= oletcnt+i) continue;
				let2[oletcnt+i] = (l&255)+(let2[j]&0xffffff00);
				break;
			}
		if (j >= 0) continue; //add to hash only if new
		let2[oletcnt+i] = (l&255)+(letn2<<8);
		hashnext[oletcnt+i] = hashead[hashval]; hashead[hashval] = oletcnt+i;
		suffixmatchtree(l>>8);
	} while (!(l&128));
}

static __forceinline __int64 rdtsc64 () { _asm rdtsc }

int initwords (char *filnam, int optimizetree)
{
	FILE *fil;
	int i, j, k, numlets;
	char word[2][MAXWORDLENG];

	fil = fopen(filnam,"rb"); if (!fil) return(0);
	numwords = maxwordleng = numlets = 0; word[0][0] = word[1][0] = 0; j = 0;
	do
	{
		fscanf(fil,"%s",word[j]);
		i = stricmp(word[j^1],word[j]);
		if (!feof(fil))
		{
			if (i > 0)
			{
				printf("Error: %s > %s! Please alphabetize word list using 'sort %s > newfile'\n",word[j^1],word[j],filnam);
				fclose(fil); return(0);
			}
			if (!i) { printf("Warning: %s listed twice!\n",word); continue; }
		}
		i = strlen(word[j]);
		numwords++; numlets += i; if (i > maxwordleng) maxwordleng = i;
		j ^= 1;
	} while (!feof(fil));

	wordsiz = maxwordleng+1;
	//printf("numwords:%d * (maxwordleng:%d + 1) = %d, numlets:%d",numwords,maxwordleng,numwords*wordsiz,numlets);

	words = (char *)malloc(numwords*wordsiz);
	memset(words,0,numwords*wordsiz);
	fseek(fil,0,SEEK_SET);
	for(i=0;i<numwords;i++)
	{
		do
		{
			fscanf(fil,"%s",&words[i*wordsiz]);
		} while ((i) && (!stricmp(&words[i*wordsiz],&words[(i-1)*wordsiz])));
	}
	fclose(fil);

	//for(i=0;i<20;i++) printf("%s\n",&words[(((rand()<<15)+rand())%numwords)*wordsiz]);

	let = (long *)malloc(numlets*sizeof(let[0])); letn = 0;
	searchsibly(0,0,numwords);

	if (optimizetree)
	{
			//Optimize tree using suffix match compression
		hashnext = (long *)malloc(letn*sizeof(hashnext[0]));
		hashead  = (long *)malloc((1<<LHASHSIZ)*sizeof(hashead[0]));
		initcrc32();
		memset(hashead,-1,(1<<LHASHSIZ)*sizeof(hashead[0]));
		let2 = (long *)malloc(numlets*sizeof(let2[0]));
		suffixmatchtree(0);
		free(let); let = let2; letn = letn2;
		let = (long *)realloc(let,letn*sizeof(let[0]));
		free(hashead); free(hashnext);
	}

#if 0
		//debug only
	for(i=0;i<letn;i++)
		printf("%d:%c,%d,%d,%d\n",i,(let[i]&31)+64,(let[i]&64)!=0,(let[i]&128)!=0,let[i]>>8);
#endif

	free(words); words = 0;
	return(1);
}

void uninitwords () { if (let) { free(let); let = 0; } }

//--------------------------------------------------------------------------------------------------

#if 0
long isword (char *st)
{
	long i, j;

	for(i=0;st[i];i++)
		if ((st[i] < 'A') || (st[i] > 'z') || ((st[i] > 'Z') && (st[i] < 'a')))
			return(0);

	if (!st[1]) return(((st[0]&31)==1)||((st[0]&31)==9));  //A and I are words!

	i = (st[0]&31)-1; j = 0;
	do
	{
		while ((let[i]^st[j])&31)
		{
			printf("%c",(let[i]&31)+96);
			if (let[i]&128) return(0);
			i++;
		}

		printf("%c",(let[i]&31)+64);
		j++;
		if (!st[j]) return((let[i]>>6)&1);
		i = (let[i]>>8);
	} while (i);
	return(0);
}
#endif

static char findst[MAXWORDLENG+1], foundst[MAXWORDLENG+1];
static long strlengminus1;

static phonelet[12] =
{
	0x0000000e, //2 ---- ----  ---- ----  ---- ----  ---- CBA-
	0x00000070, //3 ---- ----  ---- ----  ---- ----  -FED ----
	0x00000380, //4 ---- ----  ---- ----  ---- --IH  G--- ----
	0x00001c00, //5 ---- ----  ---- ----  ---L KJ--  ---- ----
	0x0000e000, //6 ---- ----  ---- ----  ONM- ----  ---- ----
	0x000d0000, //7 ---- ----  ---- SR-P  ---- ----  ---- ----
	0x00700000, //8 ---- ----  -VUT ----  ---- ----  ---- ----
	0x03800000, //9 ---- --YX  W--- ----  ---- ----  ---- ----
	0x0000827e, //: ---- ----  ---- ----  O--- --I-  -FED CBA-
	0x07df7ddc, //; ---- -ZYX  WV-T SRQP  -NML KJ-H  GF-D CB--
	0x00000000, //< (not supported on command line)
	0x00208222, //= ---- ----  --U- ----  O--- --I-  --E- --A-
};


void recursefindwords (long i, long dep)
{
	long j;

	if (findst[dep] == '?')
	{
		if (dep == strlengminus1)
			while (1)
			{
				if (let[i]&64) { foundst[dep] = (let[i]&31)+64; puts(foundst); matchcnt++; }
				if (let[i]&128) return;
				i++;
			}
		while (1)
		{
			j = (let[i]>>8);
			if (j) { foundst[dep] = (let[i]&31)+64; recursefindwords(j,dep+1); }
			if (let[i]&128) return;
			i++;
		}
	}

	if ((findst[dep] >= '2') && (findst[dep] <= '='))
	{
		if (dep == strlengminus1)
			while (1)
			{
				if (phonelet[findst[dep]-'2']&(1<<let[i]))
				{
					if (let[i]&64) { foundst[dep] = (let[i]&31)+64; puts(foundst); matchcnt++; }
				}
				if (let[i]&128) return;
				i++;
			}
		while (1)
		{
			if (phonelet[findst[dep]-'2']&(1<<let[i]))
			{
				j = (let[i]>>8);
				if (j) { foundst[dep] = (let[i]&31)+64; recursefindwords(j,dep+1); }
			}
			if (let[i]&128) return;
			i++;
		}
	}

	while (!((let[i]&31)+64 == findst[dep]))
	{
		if (let[i]&128) return;
		i++;
	}
	if (dep == strlengminus1)
	{
		if (let[i]&64) { foundst[dep] = (let[i]&31)+64; puts(foundst); matchcnt++; }
	}
	else
	{
		j = (let[i]>>8);
		if (j) { foundst[dep] = (let[i]&31)+64; recursefindwords(j,dep+1); }
	}
}

void findwords (char *st)
{
	long i, j;

	for(i=0;st[i];i++)
	{
		if (i >= maxwordleng) return;
		findst[i] = st[i];
	}
	strlengminus1 = i-1;
	findst[i] = foundst[i] = 0;
	recursefindwords(0,0);
}

void recursewildcards (char *st)
{
	long i, j, k, cnt;
	char *nst;

	for(i=0;st[i];i++)
	{
		if (st[i] != '*') continue;
		cnt = maxwordleng - strlen(st) + 1;
		for(j=i+1;st[j];j++) cnt += (st[j] == '*');
		for(j=0;j<=cnt;j++)
		{
			nst = &st[33];
			for(k=0;k<i;k++) *nst++ = st[k];
			for(k=0;k<j;k++) *nst++ = '?';
			for(k=i+1;st[k];k++) *nst++ = st[k];
			*nst++ = 0;
			recursewildcards(&st[33]);
		}
		return;
	}
	findwords(st);
}

void findwildcards (char *st)
{
	long i, j;

	strcpy(globst,st);

	for(i=0;globst[i+1];i++)
		if (((globst[i  ] == '*') || (globst[i+1] == '*')) &&
			 ((globst[i  ] == '*') || (globst[i  ] == '?')) &&
			 ((globst[i+1] == '*') || (globst[i+1] == '?')))
		{
			globst[i] = '*';
			for(j=i+1;globst[j];j++) globst[j] = globst[j+1];
			i--;
		}
	recursewildcards(globst);
}

static char ganspaces[MAXWORDLENG], ganspacen;
static int letfrq[32], gawordcnt;
void recursefindanagram (char *st, long stleng, long xhack, long x, long i)
{
	int l, eat;

	i--;
	do
	{
		i++; l = let[i];
		if ((x < stleng) && ((letfrq[l&31]) || (letfrq[31])))
		{
			eat = (l&31); st[x+xhack] = eat+64; if (!letfrq[eat]) eat = 31;
			x++; letfrq[eat]--;

			if (l&64)
			{
				st[x+xhack] = 0;
				if (x == stleng)
				{
					if ((!ganspacen) || (ganspaces[x+xhack-1] != '_')) { printf("%s\n",st); matchcnt++; }
				}
				else
				{
					st[x+xhack] = ' ';
					if ((gawordcnt > 1) && ((!ganspacen) || (ganspaces[x+xhack] == '_')))
					{
						gawordcnt--;
						recursefindanagram(st,stleng-x,x+xhack+1,0,0);
						gawordcnt++;
					}
				}
			}

			if ((!ganspacen) || (ganspaces[x+xhack-1] != '_'))
				{ if (l&0xffffff00) recursefindanagram(st,stleng,xhack,x,l>>8); }

			x--; letfrq[eat]++;
		}
	} while (!(l&128));
}

void findanagrams (char *ist, int maxwords)
{
	char tbuf[MAXWORDLENG*2];
	int i, numlets;

	strcpy(ganspaces,ist);

	memset(letfrq,0,sizeof(letfrq)); numlets = 0; ganspacen = 0;
	for(i=0;ist[i];i++)
	{
		if ((ist[i]&255) == '_') { ganspacen = 1; continue; }
		if ((((ist[i]&255) >= 'A') && ((ist[i]&255) <= 'Z')) ||
			 (((ist[i]&255) >= 'a') && ((ist[i]&255) <= 'z')) || ((ist[i]&255) == '?'))
			{ letfrq[ist[i]&31]++; numlets++; }
		else { printf("Error: invalid character '%c'. Use: A-Z, a-z, ?, or _ for anagrams\n",ist[i]&255); return; }
	}
	if (ganspacen) ganspacen = numlets;

	gawordcnt = maxwords;
	recursefindanagram(tbuf,numlets,0,0,0);
}

//--------------------------------------- BOGGLE CODE BEGINS ---------------------------------------

//static char foundst[MAXWORDLENG+1];
static char letonboard[32], board[16], gfoundit;
static long foundcnt[16];
static char touchcnt[16] = {3,5,5,3,5,8,8,5,5,8,8,5,3,5,5,3};
static char cubelets[16][6] =
{
	'B','I','R','F','O','X',  'Q','A','B','J','O','M',  'S','H','M','A','R','O',  'T','I','N','E','G','V',
	'N','E','W','D','O','S',  'T','O','A','C','I','A',  'D','A','M','P','E','C',  'F','E','I','H','E','Y',
	'L','I','W','R','U','G',  'B','I','T','L','A','Y',  'S','E','N','H','I','P',  'Z','E','N','D','A','V',
	'G','E','U','Y','L','K',  'P','U','T','S','E','L',  'S','E','L','R','A','C',  'T','O','U','D','N','K',
};
static char touch[16][8] =
{
	 1, 4, 5, 0, 0, 0, 0, 0,   0, 2, 4, 5, 6, 0, 0, 0,   1, 3, 5, 6, 7, 0, 0, 0,   2, 6, 7, 0, 0, 0, 0, 0,
	 0, 1, 5, 8, 9, 0, 0, 0,   0, 1, 2, 4, 6, 8, 9,10,   1, 2, 3, 5, 7, 9,10,11,   2, 3, 6,10,11, 0, 0, 0,
	 4, 5, 9,12,13, 0, 0, 0,   4, 5, 6, 8,10,12,13,14,   5, 6, 7, 9,11,13,14,15,   6, 7,10,14,15, 0, 0, 0,
	 8, 9,13, 0, 0, 0, 0, 0,   8, 9,10,12,14, 0, 0, 0,   9,10,11,13,15, 0, 0, 0,  10,11,14, 0, 0, 0, 0, 0,
};

void recurseboggle (long p, long i)
{
	long z;

	if (gfoundit) return;
	for(z=touchcnt[p]-1;z>=0;z--)
		if (board[touch[p][z]] == foundst[i])
		{
			if (!foundst[i+1]) { gfoundit = 1; return; }
			board[p] ^= 128; //Invalidate letter so it can't be used twice
			recurseboggle((long)touch[p][z],i+1);
			board[p] ^= 128;
		}
}

void recursefindallwords (long i, long dep)
{
	long j;

	i--;
	do
	{
		i++;
		if ((let[i]&64) && (dep >= 2))
		{
			foundst[dep] = (let[i]&31)+64; foundst[dep+1] = 0;
			gfoundit = 0;
			for(j=15;j>=0;j--)
				if (board[j] == foundst[0])
				{
					recurseboggle(j,1);
					if (gfoundit) { printf("%-16s",foundst); foundcnt[strlen(foundst)]++; break; }
				}
		}
		if (letonboard[let[i]&31])
			{ j = (let[i]>>8); if (j) { foundst[dep] = (let[i]&31)+64; recursefindallwords(j,dep+1); } }
	} while (!(let[i]&128));
}

void runboggle (char *st)
{
	long i, j, k;
	char got[16];

		//Generate random boggle board from real boggle cubes
	srand((long)rdtsc64());

	for(i=16-1;i>=0;i--) got[i] = i;
	for(i=16-1;i>=0;i--)
	{
		j = rand()%(i+1);
		board[15-i] = cubelets[got[j]][rand()%6];
		got[j] = got[i];
	}

	for(i=0;(i<16) && (st[i]);i++)
		if (((st[i] >= 'A') && (st[i] <= 'Z')) || ((st[i] >= 'a') && (st[i] <= 'z')))
			board[i] = (st[i]&31)+64;
	if ((i < 16) && (st[0] != '*')) puts("Boggle string too short!");
	if ((i == 16) && (st[16])) puts("Boggle string too long!");

	for(i=0;i<16;i++)
	{
		printf("%c ",board[i]);
		if ((i&3) == 3) puts("");
	}
	puts("");

	memset(letonboard,0,sizeof(letonboard));
	for(i=0;i<16;i++) letonboard[board[i]&31] = 1;

	memset(foundcnt,0,sizeof(foundcnt));
	recursefindallwords(0,0);

	puts("");
	j = k = 0;
	for(i=3;i<=maxwordleng;i++)
		if (foundcnt[i])
		{
			printf("%ld-letter words: %ld\n",i,foundcnt[i]);
			j += foundcnt[i]; k += foundcnt[i]*(i-2);
		}
	printf("TOTAL words found: %ld\n",j);
	printf("BOGGLE score: %ld\n",k);
}

//---------------------------------------- BOGGLE CODE ENDS ----------------------------------------

#if 0

int loadwords (char *filnam)
{
	FILE *fil;

	fil = fopen(filnam,"rb"); if (!fil) return(0);
	fread(&letn,4,1,fil);
	fread(&maxwordleng,4,1,fil);
	let = (long *)malloc(letn*sizeof(let[0])); if (!let) { fclose(fil); return(0); }
	fread(let,letn*sizeof(let[0]),1,fil);
	fclose(fil);
	return(1);
}

int savewords (char *filnam)
{
	FILE *fil;

	fil = fopen(filnam,"wb"); if (!fil) return(0);
	fwrite(&letn,4,1,fil);
	fwrite(&maxwordleng,4,1,fil);
	fwrite(let,letn*sizeof(let[0]),1,fil);
	fclose(fil);
	return(1);
}

#else

static long letbits[32] = {0,4,6,5,5,3,6,5,5,4,9,7,4,5,4,4,5,9,4,3,4,5,6,7,8,6,7};

static __forceinline long bsr (long a) { _asm bsr eax, a }

int gfixptr;
void fixforwardpointers (long i)
{
	int l;

	for(l=i;!(let[l]&128);l++);
	gfixptr += l-i+1;

	for(;i<=l;i++)
	{
		if ((((unsigned)let[i])>>8) <= i) continue;
		let[i] = (let[i]&255) + (gfixptr<<8);
		fixforwardpointers(gfixptr);
	}
}

int loadwords (char *filnam)
{
	static char letmask[512], letorder[27] =
	{
		'0',
		'A','I','R','C','B','Y','N','D','U','O','T','E','P',
		'F','K','W','G','M','S','L','H','V','Z','X','J','Q'
	};
	static char pow2char[8] = {1,2,4,8,16,32,64,128};
	FILE *fil;
	long i, j, k, numnodes, compbit, z, zcur, *siblyhead;
	char *buf;

	fil = fopen(filnam,"rb"); if (!fil) return(0);
	fseek(fil,0,SEEK_END); i = ftell(fil); fseek(fil,0,SEEK_SET);
	if (!(buf = (char *)malloc(i))) { puts("OUT OF MEMORY"); return(0); }
	fread(buf,i,1,fil);
	fclose(fil);

	numnodes = (*(long *)&buf[0]);
	letn = numnodes;
	let = (long *)malloc(letn*sizeof(let[0])); if (!let) return(0);
	maxwordleng = *(long *)&buf[4];

	if (!(siblyhead = (long *)malloc((*(long *)&buf[8])*sizeof(siblyhead[0]))))
		{ puts("OUT OF MEMORY"); return(0); }

	compbit = (12<<3);

		//Prepare Huffman tables for load letters
	k = 0;
	for(i=1;i<=26;i++)
		for(j=(512>>letbits[letorder[i]-64]);j>0;j--)
		{
			z = k;  //z = bit reverse of k
			if ((k^(k<<8))&256) z ^= (256+1);
			if ((k^(k<<6))&128) z ^= (128+2);
			if ((k^(k<<4))& 64) z ^= ( 64+4);
			if ((k^(k<<2))& 32) z ^= ( 32+8);
			letmask[z] = letorder[i]-64;
			k++;
		}

		//Load letters
	for(j=0;j<numnodes;j++)
	{
		let[j] = (long)letmask[((*(short *)&buf[compbit>>3])>>(compbit&7))&511];
		compbit += letbits[let[j]];
	}

		//Load sibly lengths (0-not tail, 1-tail)
	siblyhead[0] = 0; i = 1; k = 1;
	for(j=0;j<numnodes-1;j++)
	{
		if (let[j+1] <= let[j])
			{ let[j] |= 128; siblyhead[k++] = i; }
		else
		{
			if (buf[compbit>>3]&pow2char[compbit&7])
				{ let[j] |= 128; siblyhead[k++] = i; }
			compbit++;
		}
		i++;
	}
	let[j] |= 128;

		//Load child pointers
	zcur = 0;
	for(j=0;j<numnodes;j++)
	{
		i = (*(long *)&buf[compbit>>3])>>(compbit&7);

		if (i&1) //Backwards child pointer (rewired suffix)
		{
			compbit++;
			if (zcur > 1)
			{
				k = bsr(zcur-1)+1;
				let[j] |= (siblyhead[zcur-1-((i>>1)&((1<<k)-1))]<<8);
				compbit += k;
			}
		}
		else
		{
			if (i&2) let[j] |= 0xffffff00; //Forwards child pointer (default suffix)
			//else No child pointer
			compbit += 2;
		}

		zcur += ((let[j]>>7)&1);
	}
	gfixptr = 0; fixforwardpointers(0);

		//Load Isword
	for(j=0;j<numnodes;j++)
	{
		if (!(let[j]&0xffffff00)) { let[j] |= 64; continue; }
		if (buf[compbit>>3]&pow2char[compbit&7]) let[j] |= 64;
		compbit++;
	}

	free(siblyhead); free(buf);
	return(1);
}

static int savewords (char *filnam)
{
	static long lethuf[32] =
	{
		0,
		0x0,0x1c,0xc,0xa,0x1,0x15,0xd,0xf,0x8,0xff,0x35,0x7,0x1d,
		0x2,0x6,0x5,0x1ff,0x4,0x3,0xe,0x1a,0x1f,0x75,0x7f,0x3c,0x3f,
	};
	FILE *fil;
	long i, j, k, l, numnodes, compbit, ocompbit, z, zcur, bufsiz, *headlookup;
	unsigned short numbytes;
	unsigned char ch, *ptr, *buf;

	numnodes = letn;

		//Create list of sibly heads; # sibling lists unknown at this point, but must be <= numnodes
	bufsiz = numnodes*4;
	buf = (unsigned char *)malloc(bufsiz); if (!buf) return(0);
	headlookup = (long *)malloc(numnodes*sizeof(headlookup[0])); if (!headlookup) { free(buf); return(0); }
	k = 0;
	for(j=0;j<numnodes;j++)
	{
		headlookup[j] = k;
		k += ((let[j]>>7)&1);
	}

	fil = fopen(filnam,"wb");
	if (!fil) { printf("Error: %d could not be opened\n",filnam); return(0); }

	fwrite(&numnodes,4,1,fil);    //Write # of nodes
	fwrite(&maxwordleng,4,1,fil); //Write maxworleng
	fwrite(&k,4,1,fil);           //Write # of sibly lists
	printf("\nStatistics:\n");
	printf("      numwords:%9d\n",numwords);
	printf("   max letters:%9d\n",maxwordleng);
	printf("      numnodes:%9d\n",numnodes);
	printf(" sibling lists:%9d\n\n",k);

	printf("File structure:\n");
	printf("        Header:%9d   bytes\n",ftell(fil));

	memset(buf,0,bufsiz);
	compbit = 0;

		//Write letters
	ocompbit = compbit;
	for(j=0;j<numnodes;j++)
	{
		*(short *)&buf[compbit>>3] |= (lethuf[let[j]&31]<<(compbit&7));
		compbit += letbits[let[j]&31];
	}
	i = compbit-ocompbit; printf("       Letters:%9d.%d bytes\n",i>>3,i&7);

		//Write sibly length list (0-not tail, 1-tail)
	ocompbit = compbit;
	for(j=0;j<numnodes-1;j++)
		if ((let[j+1]&31) > (let[j]&31))
		{
			if (let[j]&128) buf[compbit>>3] |= (1<<(compbit&7));
			compbit++;
		}
	i = compbit-ocompbit; printf(" Sibly lengths:%9d.%d bytes\n",i>>3,i&7);

		//Write child pointers
	ocompbit = compbit;
	for(j=0;j<numnodes;j++)
	{
		zcur = headlookup[j]; z = headlookup[let[j]>>8];
		if ((z) && (z < zcur)) //Backwards child pointer (rewired suffix)
		{
			buf[compbit>>3] |= (1<<(compbit&7)); compbit++;
			if (zcur > 1) { *(long *)&buf[compbit>>3] |= ((zcur-1-z)<<(compbit&7)); compbit += bsr(zcur-1)+1; }
		}
		else
		{
			compbit++; if (z) buf[compbit>>3] |= (1<<(compbit&7)); //Forwards child pointer (default suffix)
			compbit++; //else No child pointer
		}
	}
	free(headlookup);
	i = compbit-ocompbit; printf("Child pointers:%9d.%d bytes\n",i>>3,i&7);

		//Write IsWord
	ocompbit = compbit;
	for(j=0;j<numnodes;j++)
		if (let[j]&0xffffff00)
		{
			if (let[j]&64) buf[compbit>>3] |= (1<<(compbit&7));
			compbit++;
		}
	i = compbit-ocompbit; printf("        IsWord:%9d.%d bytes\n",i>>3,i&7);

	fwrite(buf,(compbit+7)>>3,1,fil);
	free(buf);
	printf("--------------------------------\n");
	printf("     KDICT.KZP:%9d   bytes\n",ftell(fil));
	fclose(fil);
	return(1);
}

#endif

void showhelp ()
{
	puts("FINDWORD ((/a# OR /b OR /c) [string]) OR (/use:..) OR (/comp:..) OR (/dump:..)");
	printf("by Ken Silverman (http://advsys.net/ken)                  Compiled: %s\n\n",__DATE__);
	puts("/a           Search anagrams. Wildcard char: ?  Force space at pos: _");
	puts("/a#          Search anagrams, specifying maximum word count.");
	puts("/b *         Search Boggle. * generetes random board using actual Boggle cubes");
	puts("/b [string]  Search Boggle. Specify 4x4 Boggle board as 16 char string: L-R,T-B");
	puts("/c [string]  Search crossword. ? and * wildcards supported. More special chars:");
	puts("                (Phone) 2 ABC  3 DEF    = vowel     (AEIOU)");
	puts("                 4 GHI  5 JKL  6 MNO    ; consonant (BCDFGHJKLMNPQRSTVWXYZ)");
	puts("                 7 PRS  8 TUV  9 WXY    : hex char  (ABCDEFIO)");
	puts("/use:[file]  Use alternate word list");
	puts("/comp:[file] Compress word list to KDICT.KZP (smaller & loads much faster!)");
	puts("/dump:[file] Decompress word list to specified file (raw text format)\n");
	puts("Examples: findword /a hers_tinyblank           findword 2ui?3 e;g=n= 6784625");
	puts("          findword /a1 stop                    findword *gry");
	puts("          findword /b *                        findword *=====*");
	puts("          findword /b multilpicatiqjno         findword /comp:sowpods.txt");
	puts("          findword /c ::::::::                 findword /use:twl06.txt :=P\n");
	puts("Default word list from here: http://scrabulous.com/sowpods_dictionary.php");
}

int main (int argc, char **argv)
{
	int i, j, anagrams = 0, boggle = 0, gotfindst = 0;
	char tbuf[1024];

	strcpy(tbuf,"kdict.kzp");
	for(i=1;i<argc;i++)
	{
		if ((argv[i][0] == '-') || (argv[i][0] == '/'))
		{
			if (!memicmp(&argv[i][1],"a",1))
			{
				if (argv[i][2]) anagrams = min(max(atol(&argv[i][2]),1),MAXWORDLENG);
							  else anagrams = MAXWORDLENG;
				boggle = 0;
				continue;
			}
			if (!stricmp(&argv[i][1],"b")) { anagrams = 0; boggle = 1; continue; }
			if (!stricmp(&argv[i][1],"c")) { anagrams = 0; boggle = 0; continue; }
			if (!memicmp(&argv[i][1],"use:",4))
			{
				strcpy(tbuf,&argv[i][5]);
				j = strlen(tbuf);
				if ((j >= 4) && (!stricmp(&tbuf[j-4],".kzp"))) printf("Using %s.\n",tbuf);
				else printf("Using %s.\nNote: run 'findword /comp:%s' for faster load\n",tbuf,tbuf);
				continue;
			}
			if (!memicmp(&argv[i][1],"comp:",5))
			{
				if (!initwords(&argv[i][6],1)) { printf("Error: %s not found",&argv[i][6]); return(1); }
				if (!savewords("kdict.kzp")) printf("Error saving kdict.kzp");
				return(0);
			}
			if (!memicmp(&argv[i][1],"dump:",5))
			{
				if (!loadwords("kdict.kzp")) { printf("Error loading kdict.kzp"); return(1); }
				gdumpfil = fopen(&argv[i][6],"wb");
				if (!gdumpfil) { printf("Error saving %s\n",&argv[i][6]); uninitwords(); return(1); }
				dumpwords(tbuf,0,0);
				fclose(gdumpfil);
				printf("Decompress KDICT.KZP to %s done.\n",&argv[i][6]);
				return(0);
			}
			printf("Unrecognized option: %s\n",argv[i]); continue;
		}
		gotfindst = 1;
	}
	if (!gotfindst) { showhelp(); return(1); }

	i = strlen(tbuf);
	if ((i >= 4) && (!stricmp(&tbuf[i-4],".kzp"))) j = loadwords(tbuf); else j = 0;
	if ((!j) && (!initwords(tbuf,0))) { printf("Error: load %s failed",tbuf); return(1); }

	for(i=1;i<argc;i++)
	{
		if ((argv[i][0] == '-') || (argv[i][0] == '/')) continue;

		for(j=0;argv[i][j];j++)
			{ tbuf[j] = argv[i][j]; if ((tbuf[j] >= 'a') && (tbuf[j] <= 'z')) tbuf[j] -= 32; }
		tbuf[j] = 0;

			  if (boggle)    runboggle(tbuf);
		else if (!anagrams) findwildcards(tbuf);
							else findanagrams(tbuf,anagrams);
	}
	if (!boggle) { if (matchcnt == 1) printf("1 match found."); else printf("%d matches found.",matchcnt); }
	uninitwords();

	return(0);
}

#if 0
!endif
#endif
